@echo off
setlocal

rem Sometime will generate a NdLIsten() error return using 2 nodes with 128 ranks.

rem test requires at least 2 nodes
set NC=2

set NODE0_IPOIB=10.10.4.202
set NODE1_IPOIB=10.10.4.152
set NODE2_IPOIB=10.10.4.159

rem Set Intel MPI release
set IMV=5.1.1.110

set MPIB=%ProgramFiles(x86)%\IntelSWTools\MPI\%IMV%\intel64\bin

set IMB=%MPIB%\imb-mpi1.exe

set THISMPI=%MPIB%\mpiexec.exe

IF NOT EXIST "%THISMPI%" (
    echo "Missing %THISMPI%"
    exit /B
)

IF  "%1" == "/?" (
:usage
    echo.
    echo usage:
    echo   %0 rank-count
    echo.
    echo   IMB test, 128 ranks can produce ND_INVALID_PARAMETER
    echo   example: %0 128
    exit /B
)
IF "%1" == "" goto usage

rem MPI rank count
set RANKS=%1%

set T=PingPong
set TT=PingPong

set MPI_DEV=rdma:ND0

rem Override install defaults if necessary
rem set DC=%SystemDrive%\Dat\dat.conf
rem set DC=C:\Temp\DAPL-ND\dat.conf
rem set MPI_EXTRA=-env DAT_OVERRIDE %DC% 

set MPI_ENV=-env I_MPI_FALLBACK_DEVICE 0 -env I_MPI_DEVICE %MPI_DEV% %MPI_EXTRA%

rem build MPI -hosts args: num_hosts host-addr0 ranks host_addr1 ranks

set LP=%NODE0_IPOIB% %RANKS%

if %NC% EQU 1 (
  set LST=%LP%
  goto NODES_OK
)

if %NC% EQU 2 (
  set LST=%NODE1_IPOIB% %RANKS% %LP%
  goto NODES_OK
)
if %NC% EQU 3 (
  set LST=%NODE2_IPOIB% %RANKS% %NODE1_IPOIB% %RANKS% %LP%
  goto NODES_OK
)

:NODES_OK

rem echo %NC% nodes, List '%LST%'
rem exit /B

@echo %0: MPI IMB %TT% [%RANKS% process/node] %MPI_DEV% on %NC% nodes

rem debug
echo "%THISMPI%" -hosts %NC% %LST% %MPI_ENV% "%IMB% %T%"

"%THISMPI%" -hosts %NC% %LST% %MPI_ENV% "%IMB%" %T%

if %ERRORLEVEL% NEQ 0 (
    echo "%THISMPI% execution FAILED - Status %ERRORLEVEL%"
    echo "%THISMPI%" -hosts %NC% %LST% %MPI_ENV% "%IMB% %T%"
    exit /B %ERRORLEVEL%
)

echo %0: MPI IMB %TT% [%RANKS% process/node] %MPI_DEV% on %NC% nodes

endlocal

